/**
 * Assignment #6: Page Replacement Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include <vector>
#include "FIFO.h"

using namespace std;

int    FIFO::total_hit_count  = 0;
double FIFO::total_swap_count = 0;

void FIFO::init()
{
    fifo.clear();
}

void FIFO::load_page(const int ref)
{
    for (auto it = fifo.begin(); it != fifo.end(); it++)
    {
        if (ref == *it) return;
    }

    fifo.push_back(ref);
}

int FIFO::choose_victim_frame(const int ref_index)
{
    int oldest_ref = fifo.front();
    int oldest_frame = which_frame(oldest_ref);
    fifo.erase(fifo.begin());

    return oldest_frame;
}

void FIFO::record_hit()
{
    ++total_hit_count;
}

void FIFO::record_swap(double amount)
{
    total_swap_count += amount;
}
