/**
 * Assignment #6: Page Replacement Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include "LFU.h"

using namespace std;

int    LFU::total_hit_count  = 0;
double LFU::total_swap_count = 0;

void LFU::init()
{
    frequencies = vector<int>(ref_string.size(), 0);
}

void LFU::load_page(const int ref)
{
    frequencies[ref]++;
}

int LFU::choose_victim_frame(const int ref_index)
{
    int least_freq = ref_string.size();
    int least_frame;

    for (int i = 0; i < frame_count; i++)
    {
        int ref = frames[i];
        if (frequencies[ref] < least_freq)
        {
            least_freq = frequencies[ref];
            least_frame = i;
        }
    }

    return least_frame;
}

void LFU::record_hit()
{
    ++total_hit_count;
}

void LFU::record_swap(double amount)
{
    total_swap_count += amount;
}
