/**
 * Assignment #6: Page Replacement Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#ifndef LFU_H_
#define LFU_H_

#include "ReplacementAlgorithm.h"

using namespace std;

class LFU: public ReplacementAlgorithm
{
public:
    LFU(string name, vector<int>& ref_string, const int max_ref,
            vector<int>& frames, const int frame_count)
        : ReplacementAlgorithm(name, ref_string, frames, frame_count)
    {}

    virtual ~LFU() {}

    int    get_total_hit_count()  const { return total_hit_count;  }
    double get_total_swap_count() const { return total_swap_count; }

private:
    vector<int> frequencies;

    void init();
    void load_page(const int ref);
    int choose_victim_frame(const int ref_index);
    void record_hit();
    void record_swap(const double amount);

    static int    total_hit_count;
    static double total_swap_count;
};

#endif /* LFU_H_ */
