/**
 * Assignment #6: Page Replacement Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include <vector>
#include "LRU.h"

using namespace std;

int    LRU::total_hit_count  = 0;
double LRU::total_swap_count = 0;

void LRU::init()
{
    lru.clear();
}

void LRU::load_page(const int ref)
{
    for (auto it = lru.begin(); it != lru.end(); it++)
    {
        if (ref == *it)
        {
            lru.erase(it);
            lru.push_back(ref);
            return;
        }
    }

    lru.push_back(ref);
}

int LRU::choose_victim_frame(const int ref_index)
{
    int least_freq_ref = lru.front();
    int least_freq_frame = which_frame(least_freq_ref);
    lru.erase(lru.begin());

    return least_freq_frame;
}

void LRU::record_hit()
{
    ++total_hit_count;
}

void LRU::record_swap(double amount)
{
    total_swap_count += amount;
}
