/**
 * Assignment #6: Page Replacement Algorithms
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include <iostream>
#include "ReplacementAlgorithm.h"

using namespace std;

void ReplacementAlgorithm::run(const int run_index)
{
    init();
    frames.clear();
    hit_count = swap_count = 0;

    cout << endl;
    for (int i = 0; i < name.size() + 3; i++) cout << "-"; cout << endl;
    cout << name << " #" << run_index << endl;
    for (int i = 0; i < name.size() + 3; i++) cout << "-"; cout << endl << endl;
    cout << "Ref  Frames    Action" << endl;

    for (int i = 0; i < ref_string.size(); i++)
    {
        int ref = ref_string[i];
        cout << " " << ref;

        int evicted_ref;
        int victim_frame = -1;

        if (which_frame(ref) > -1)
        {
            hit_count++;
            record_hit();
        }
        else
        {
            if (frames.size() < frame_count)
            {
                frames.push_back(ref);
                swap_count += 0.5;
                record_swap(0.5);
            }
            else
            {
                victim_frame = choose_victim_frame(i);
                evicted_ref = frames[victim_frame];

                frames[victim_frame] = ref;
                swap_count += 1;
                record_swap(1.0);
            }

            cout << "   ";
            for (int i = 0; i < frame_count; i++)
            {
                if (i < frames.size()) cout << " " << frames[i];
                else                   cout << "  ";
            }

            cout << "    ";
            if (victim_frame >= 0) cout << "evicted " << evicted_ref << ", ";
            cout << "paged in " << ref;
        }

        load_page(ref);
        cout << endl;
    }

    print_stats();
}

int ReplacementAlgorithm::which_frame(const int ref)
{
    for (int index = 0; index < frames.size(); index++)
    {
        if (ref == frames[index]) return index;
    }

    return -1;
}

void ReplacementAlgorithm::print_stats()
{
    cout << endl << name << " statistics:" << endl;
    cout << "  Swap count = " << swap_count << endl;
    cout << "   Hit count = " << hit_count << endl;
    cout << "   Hit ratio = " << ((double)hit_count)/ref_string.size() << endl;
}
